io.vertx.rxjava.ext.web.handler.sockjs

## Class SockJSSocket

- java.lang.Object
- - io.vertx.rxjava.ext.web.handler.sockjs.SockJSSocket

- All Implemented Interfaces:
    ReadStream<Buffer>, StreamBase, WriteStream<Buffer>

      public class SockJSSocket
      extends Object
      implements ReadStream<Buffer>, WriteStream<Buffer>

  You interact with SockJS clients through instances of SockJS socket.

  The API is very similar to `WebSocket`. It implements both and so it can be used with `Pump` to pump data with flow control.

  NOTE: This class has been automatically generated from the `original` non RX-ified interface using Vert.x codegen.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `SockJSSocket(SockJSSocket delegate)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Close it
    `SockJSSocket` | `drainHandler(Handler<Void> handler)` Set a drain handler on the stream.
    `void` | `end()` Call `end(io.vertx.rxjava.core.buffer.Buffer)`.
    `void` | `end(Buffer t)` Same as `WriteStream.end()` but writes some data to the stream before ending.
    `SockJSSocket` | `endHandler(Handler<Void> endHandler)` Set an end handler.
    `SockJSSocket` | `exceptionHandler(Handler<Throwable> handler)` Set an exception handler on the read stream.
    `Object` | `getDelegate()`
    `SockJSSocket` | `handler(Handler<Buffer> handler)` Set a data handler.
    `MultiMap` | `headers()` Return the headers corresponding to the last request for this socket or the websocket handshake Any cookie headers will be removed for security reasons
    `SocketAddress` | `localAddress()` Return the local address for this socket
    `static SockJSSocket` | `newInstance(SockJSSocket arg)`
    `SockJSSocket` | `pause()` Pause the `ReadSupport`.
    `SocketAddress` | `remoteAddress()` Return the remote address for this socket
    `SockJSSocket` | `resume()` Resume reading.
    `SockJSSocket` | `setWriteQueueMaxSize(int maxSize)` Set the maximum size of the write queue to `maxSize`.
    `Observable<Buffer>` | `toObservable()`
    `String` | `uri()` Return the URI corresponding to the last request for this socket or the websocket handshake
    `Session` | `webSession()`
    `User` | `webUser()`
    `SockJSSocket` | `write(Buffer data)` Write some data to the stream.
    `String` | `writeHandlerID()` When a `SockJSSocket` is created it automatically registers an event handler with the event bus, the ID of that handler is given by `writeHandlerID`.
    `boolean` | `writeQueueFull()` This will return `true` if there are more bytes in the write queue than the value set using `WriteStream.setWriteQueueMaxSize(int)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface io.vertx.rxjava.core.streams.ReadStream

      `newInstance`

    - ### Methods inherited from interface io.vertx.rxjava.core.streams.WriteStream

      `newInstance`

    - ### Methods inherited from interface io.vertx.rxjava.core.streams.StreamBase

      `newInstance`

- - ### Constructor Detail

    - #### SockJSSocket

          public SockJSSocket(SockJSSocket delegate)

  - ### Method Detail

    - #### getDelegate

          public Object getDelegate()

      Specified by:
        `getDelegate` in interface `ReadStream<Buffer>`
      Specified by:
        `getDelegate` in interface `StreamBase`
      Specified by:
        `getDelegate` in interface `WriteStream<Buffer>`

    - #### toObservable

          public Observable<Buffer> toObservable()

      Specified by:
        `toObservable` in interface `ReadStream<Buffer>`

    - #### end

          public void end(Buffer t)

      Description copied from interface: `WriteStream`
      Same as `WriteStream.end()` but writes some data to the stream before ending.
      Specified by:
        `end` in interface `WriteStream<Buffer>`

    - #### writeQueueFull

          public boolean writeQueueFull()

      Description copied from interface: `WriteStream`
      This will return `true` if there are more bytes in the write queue than the value set using `WriteStream.setWriteQueueMaxSize(int)`
      Specified by:
        `writeQueueFull` in interface `WriteStream<Buffer>`
      Returns:
        true if write queue is full

    - #### exceptionHandler

          public SockJSSocket exceptionHandler(Handler<Throwable> handler)

      Description copied from interface: `ReadStream`
      Set an exception handler on the read stream.
      Specified by:
        `exceptionHandler` in interface `ReadStream<Buffer>`
      Specified by:
        `exceptionHandler` in interface `StreamBase`
      Specified by:
        `exceptionHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the exception handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### handler

          public SockJSSocket handler(Handler<Buffer> handler)

      Description copied from interface: `ReadStream`
      Set a data handler. As data is read, the handler will be called with the data.
      Specified by:
        `handler` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### pause

          public SockJSSocket pause()

      Description copied from interface: `ReadStream`
      Pause the `ReadSupport`. While it's paused, no data will be sent to the `dataHandler`
      Specified by:
        `pause` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### resume

          public SockJSSocket resume()

      Description copied from interface: `ReadStream`
      Resume reading. If the `ReadSupport` has been paused, reading will recommence on it.
      Specified by:
        `resume` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### endHandler

          public SockJSSocket endHandler(Handler<Void> endHandler)

      Description copied from interface: `ReadStream`
      Set an end handler. Once the stream has ended, and there is no more data to be read, this handler will be called.
      Specified by:
        `endHandler` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### write

          public SockJSSocket write(Buffer data)

      Description copied from interface: `WriteStream`
      Write some data to the stream. The data is put on an internal write queue, and the write actually happens asynchronously. To avoid running out of memory by putting too much on the write queue, check the `WriteStream.writeQueueFull()` method before writing. This is done automatically if using a `Pump`.
      Specified by:
        `write` in interface `WriteStream<Buffer>`
      Parameters:
        `data` - the data to write
      Returns:
        a reference to this, so the API can be used fluently

    - #### setWriteQueueMaxSize

          public SockJSSocket setWriteQueueMaxSize(int maxSize)

      Description copied from interface: `WriteStream`
      Set the maximum size of the write queue to `maxSize`. You will still be able to write to the stream even if there is more than `maxSize` bytes in the write queue. This is used as an indicator by classes such as `Pump` to provide flow control.
      Specified by:
        `setWriteQueueMaxSize` in interface `WriteStream<Buffer>`
      Parameters:
        `maxSize` - the max size of the write stream
      Returns:
        a reference to this, so the API can be used fluently

    - #### drainHandler

          public SockJSSocket drainHandler(Handler<Void> handler)

      Description copied from interface: `WriteStream`
      Set a drain handler on the stream. If the write queue is full, then the handler will be called when the write queue has been reduced to maxSize / 2. See `Pump` for an example of this being used.
      Specified by:
        `drainHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### writeHandlerID

          public String writeHandlerID()

      When a `SockJSSocket` is created it automatically registers an event handler with the event bus, the ID of that handler is given by `writeHandlerID`.

      Given this ID, a different event loop can send a buffer to that event handler using the event bus and that buffer will be received by this instance in its own event loop and written to the underlying socket. This allows you to write data to other sockets which are owned by different event loops.

      Returns:

    - #### end

          public void end()

      Call `end(io.vertx.rxjava.core.buffer.Buffer)`.
      Specified by:
        `end` in interface `WriteStream<Buffer>`

    - #### close

          public void close()

      Close it

    - #### remoteAddress

          public SocketAddress remoteAddress()

      Return the remote address for this socket
      Returns:

    - #### localAddress

          public SocketAddress localAddress()

      Return the local address for this socket
      Returns:

    - #### headers

          public MultiMap headers()

      Return the headers corresponding to the last request for this socket or the websocket handshake Any cookie headers will be removed for security reasons
      Returns:

    - #### uri

          public String uri()

      Return the URI corresponding to the last request for this socket or the websocket handshake
      Returns:

    - #### webSession

          public Session webSession()

      Returns:
        the Vert.x-Web session corresponding to this socket

    - #### webUser

          public User webUser()

      Returns:
        the Vert.x-Web user corresponding to this socket

    - #### newInstance

          public static SockJSSocket newInstance(SockJSSocket arg)

Copyright © 2016. All rights reserved.